﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Jewels
{
    public partial class Form1 : Form
    {
        Map m;
        
        public Form1()
        {
            InitializeComponent();
            button2.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)//NACTENI MAPY
        {
            button2.Enabled = true;
            m = new Map();
            Stream myStream = null;
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.InitialDirectory = "c:\\";
            openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    if ((myStream = openFileDialog1.OpenFile()) != null)
                    {
                        using (myStream)
                        {
                            StreamReader sr = new StreamReader(myStream);
                            for (int i = 0; i < 8; i++)
                            {
                                var line = sr.ReadLine();
                                var array = line.ToCharArray();
                                var betterArray = new int[array.Length];
                                for (int yi = 0; yi < array.Length; yi++)
                                {
                                    betterArray[yi] = int.Parse(array[yi].ToString());
                                }
                                ////
                                for (int z = 0; z < betterArray.Length; z++)
                                {
                                    m.jewels[i, z] = m.jeweltypes[betterArray[z]];
                                }
                            }
                            for (int i = 0; i < 8; i++)
                            {
                                var line = sr.ReadLine();
                                var array = line.ToCharArray();
                                var betterArray = new int[array.Length];
                                for (int yi = 0; yi < array.Length; yi++)
                                {
                                    betterArray[yi] = int.Parse(array[yi].ToString());
                                }
                                ////
                                for (int z = 0; z < betterArray.Length; z++)
                                {
                                    m.jewelCollums[i].Add(m.jeweltypes[betterArray[z]]);
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    button2.Enabled = false;
                    MessageBox.Show("SOMETHING WENT WRONG :/ Original error: " + ex.Message);
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)//ZACNUTI HRY
        {

            Game g = new Game(m);
            if (checkBox1.Checked)
            {
                try
                {
                    var seconds = textBox1.Text.Split(new string[] { ":" }, StringSplitOptions.RemoveEmptyEntries)[1];
                    var minutes = textBox1.Text.Split(new string[] { ":" }, StringSplitOptions.RemoveEmptyEntries)[0];

                    g.endTime = DateTime.Now +new TimeSpan(0, int.Parse(minutes), int.Parse(seconds));
                    g.startTimer();
                    g.timerEnabled = true;
                }
                catch
                {
                    MessageBox.Show("NUUUU.. Spatne zadany format casu");
                    return;
                }
            }
            g.ShowDialog();
            button2.Enabled = false;
        }
    }
}
