﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace Jewels
{
    public class Map //CLASSA NA ULOZENI MAPY
    {
        public List<jewel> jeweltypes = new List<jewel>();//TYPY DIAMANTU
        public jewel[,] jewels = new jewel[8,8];
        public List<int> next = new List<int>();
        public List<List<jewel>> jewelCollums= new List<List<jewel>>();
        public Map() //inicializace MAPY
        {
            
            for (int i = 0; i < 8; i++)
            {
                next.Add(0);
                jewelCollums.Add(new List<jewel>());
            }
            jeweltypes.Add(new jewel() { Id = 0, Color = Color.Orange });
            jeweltypes.Add(new jewel() { Id = 1, Color = Color.Red });
            jeweltypes.Add(new jewel() { Id = 2, Color = Color.Green });
            jeweltypes.Add(new jewel() { Id = 3, Color = Color.Blue });
            jeweltypes.Add(new jewel() { Id = 4, Color = Color.White });
            jeweltypes.Add(new jewel() { Id = 5, Color = Color.Yellow });
            jeweltypes.Add(new jewel() { Id = 6, Color = Color.Purple });
            for (int x = 0; x < jewels.GetLength(0); x++)
            {
                for (int y = 0; y < jewels.GetLength(1); y++)
                {
                    jewels[x, y] = new jewel();
                }
            }
        }
        public jewel get(Point p) //ZISKANI POLICKA Z POINTU
        {
            return (jewels[p.X, p.Y]);
        }
        public jewel getNext(int collum) //ZISKANI DALSI DIAMANTY KTERA TAM SPADNE
        {
            var toRet = jewelCollums[collum][next[collum]];
            next[collum]++;
            if (next[collum] > jewelCollums[collum].Count-1)
                next[collum] = 0;
            return toRet;
        }
        public jewel peekNext(int collum) //ZJISTIT DALSI DIAMANT, ALE NENARVAT HO DO MAPY
        {
            if (next[collum] > jewelCollums[collum].Count-1)
                return jewelCollums[collum][0];
            else
                return jewelCollums[collum][next[collum]];
        }
    }
    public class jewel //DIAMANT CLASSA
    {
        public int Id;
        public Color Color;
        public jewel()
        {
            Color = Color.Orange; //DDEFAULT BARVA/ERROR BARBA
        }
    }
}
